<template>
  <div ref="parentSidebar" id="parentx">
    <vs-button
      @click="active = !active"
      color="primary"
      icon="menu"
      type="filled"
    ></vs-button>
    <vs-sidebar
      :parent="$refs.parentSidebar"
      default-index="1"
      color="primary"
      class="sidebarx"
      spacer
      v-model="active"
    >
      <template #header>
        <div class="icon">
          <h1>
            <a class="a1" href="/">
              <div class="waviy">World of fantasy</div>
            </a>
          </h1>
        </div>
      </template>
      <vs-sidebar-group title="Categories by year">
        <router-link :to="{ path: '', query: { year: number } }">
          <vs-sidebar-item
            @click="numberYear(number)"
            v-for="number in 15"
            :key="number"
          >
            {{ 2024 - number }}
          </vs-sidebar-item>
        </router-link>
        <div>
          <div class="search_rep">
            <p>"In this field you can search by reptiles"</p>
            <input
              type="text"
              placeholder="Search by year"
              class="inp_year"
              maxlength="4"
              v-model="number"
              @keyup.enter="numberYear(2024 - number)"
            />
          </div>
        </div>
      </vs-sidebar-group>
      <vs-sidebar-group title="Categories by genre">
        <router-link :to="{ path: '', query: { ganre: genre.name } }">
          <vs-sidebar-item
            class="item-blok"
            v-for="genre in animeMoviesStore.animeGenres"
            :key="genre.mal_id"
            @click="selectGenre(genre)"
            >{{ genre.name }}</vs-sidebar-item
          >
        </router-link>
      </vs-sidebar-group>
    </vs-sidebar>
  </div>
</template>

<script>
import { mapStores } from "pinia"
import { useAnimeMoviesStore } from "../stores/AnimeMoviesStores"
import { useMangaReadingStore } from "../stores/MangaReadingStore"

export default {
  data() {
    return {
      active: false,
      number: null,
      genre: ""
    }
  },
  mounted() {
    if (this.$route.path === "/" || this.$route.path === "/anime") { this.animeMoviesStore.fetchAnimeGenres() }
    else if (this.$route.path === "/manga") { this.mangaReadingStore.fetchMangaGenres() }
  },
  methods: {
    numberYear(number) {
      this.number = 2024 - number
      if (this.$route.path === "/" || this.$route.path === "/anime") {
        this.animeMoviesStore.fetchAnimeYear(this.number)
        window.scrollTo({ "top": 0 });
      }
      else if (this.$route.path === "/manga") {
        this.mangaReadingStore.fetchMangaYear(this.number)
        window.scrollTo({ "top": 0 });
      }
    },
    selectGenre(genre) {
      if (this.$route.path === "/" || this.$route.path === "/anime") {
        this.genre = genre
        this.animeMoviesStore.fetchAnimeBySearchGenres(genre.mal_id)
        window.scrollTo({ "top": 0 });
      }
      else if (this.$route.path === "/manga") {
        this.genre = genre
        this.mangaReadingStore.fetchMangaBySearchGenres(genre.mal_id)
        window.scrollTo({ "top": 0 });
      }

    }
  },
  computed: mapStores(useMangaReadingStore, useAnimeMoviesStore),
}
</script>
